VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cThread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Busy As Boolean
Private Colors As Long
Private MaxIterations As Long
Private LUT() As Long
Private pRow(16384) As Long 'preserve a RowBuffer

Private ForkForm As ForkForm
Private WithEvents ForkTimer As Timer
Attribute ForkTimer.VB_VarHelpID = -1

Private mToCallBack As ICallback
Private mIndex As Integer
Private mIdxStart As Long
Private mIdxEnd As Long
Private mMX As Double
Private mMY As Double
Private mxStep As Double
Private myStep As Double
Private mRowWidth As Long

Public Sub CancelProcessing()
    Busy = False 'just reset the Busy-Flag...
End Sub

Public Sub CalcMBPart( _
    ByVal ToCallBack As Object, _
    ByVal Index As Integer, _
    ByVal IdxStart As Long, _
    ByVal IdxEnd As Long, _
    ByVal MX As Double, _
    ByVal MY As Double, _
    ByVal xStep As Double, _
    ByVal yStep As Double, _
    ByVal RowWidth As Long)
    'This code blocks the calling thread.

    Set mToCallBack = ToCallBack
    mIndex = Index
    mIdxStart = IdxStart
    mIdxEnd = IdxEnd
    mMX = MX
    mMY = MY
    mxStep = xStep
    myStep = yStep
    mRowWidth = RowWidth
    
    ForkTimer.Enabled = True
End Sub

Private Sub RunCalcMBPart()
    'This code runs on our own thread.
    Dim i As Long, x As Double, y As Double, Stp As Long

    Busy = True
    If mIdxStart <= mIdxEnd Then Stp = 1 Else Stp = -1
    
    For i = mIdxStart To mIdxEnd Step Stp
        y = i * myStep + mMY
        
        For x = 0 To mRowWidth - 1
            pRow(x) = MBColor(x * mxStep + mMX, y)
        Next x
        
        mToCallBack.RowFinished mIndex, VarPtr(pRow(0)), i
        If App.LogMode = 0 Then DoEvents 'only called, if we run in IDE-Mode (to give a bit of breathing-space)
        If Not Busy Then Exit Sub  'a thread interruption came from outside
    Next i
    Busy = False
End Sub

Private Function MBColor(cx#, cy#) As Long
    Dim x#, y#, x2#, y2#, i&
    
    x = cx: y = cy
    For i = 0 To MaxIterations - 1
        x2 = x * x: y2 = y * y
        If (x2 + y2) > 4# Then
            MBColor = LUT((i Mod Colors))
            Exit Function
        End If
        y = (2 * x * y) + cy
        x = x2 - y2 + cx
    Next i
End Function

Private Sub InitializeLUT()
    Dim i&, k&, Up255&, Dn255&, R&, G&, B&, RDrk&, GDrk&, BDrk&
    
    ReDim LUT(Colors - 1)
    k = Colors / 7 'divide colors into 7 ranges
    For i = 0 To Colors - 1
        Up255 = (i Mod k) * 255 / k: Dn255 = 255 - Up255
        Select Case i \ k
            Case 0: B = Up255
            Case 1: B = Dn255: R = Up255
            Case 2: B = Up255
            Case 3: B = Dn255: R = Dn255: G = Up255
            Case 4: B = Up255
            Case 5: B = Dn255: R = Up255
            Case 6: B = Up255
        End Select
        RDrk = R: GDrk = G * 0.7: BDrk = B * 0.9
        LUT(i) = RGB(RDrk, GDrk, BDrk)
    Next i
End Sub

Private Sub Class_Initialize()
    MaxIterations = 1024 'define the Depth
    Colors = MaxIterations / 2 'define the mapped Color-Range
    InitializeLUT

    Set ForkForm = New ForkForm
    Set ForkTimer = ForkForm.ForkTimer 'Causes the Form to Load.
End Sub

Private Sub Class_Terminate()
    Set mToCallBack = Nothing
    Unload ForkForm
End Sub

Private Sub ForkTimer_Timer()
    ForkTimer.Enabled = False
    RunCalcMBPart
End Sub
