VERSION 5.00
Begin VB.Form fMBSet 
   Caption         =   "DMBSet multithreaded"
   ClientHeight    =   8220
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10560
   LinkTopic       =   "Form1"
   ScaleHeight     =   548
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   704
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer tmrRefresh 
      Enabled         =   0   'False
      Interval        =   15
      Left            =   5520
      Top             =   60
   End
   Begin VB.CheckBox chkSingle 
      Caption         =   "Singlethreaded"
      Height          =   255
      Left            =   960
      TabIndex        =   3
      Top             =   75
      Width           =   1485
   End
   Begin VB.CommandButton cmdRecalc 
      Caption         =   "Recalc"
      Default         =   -1  'True
      Height          =   285
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   825
   End
   Begin VB.PictureBox picSrf 
      Align           =   2  'Align Bottom
      AutoRedraw      =   -1  'True
      Height          =   7740
      Left            =   0
      ScaleHeight     =   512
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   700
      TabIndex        =   0
      Top             =   480
      Width           =   10560
      Begin VB.Shape shpZoom 
         BorderColor     =   &H00000000&
         BorderStyle     =   3  'Dot
         DrawMode        =   6  'Mask Pen Not
         Height          =   405
         Left            =   360
         Top             =   510
         Visible         =   0   'False
         Width           =   675
      End
   End
   Begin VB.Label lblTiming 
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   2490
      TabIndex        =   2
      Top             =   60
      Width           =   1485
   End
End
Attribute VB_Name = "fMBSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements ICallback

Private Declare Function StretchDIBits& Lib "gdi32" (ByVal hdc&, ByVal x&, ByVal y&, ByVal dx&, ByVal dy&, ByVal SrcX&, ByVal SrcY&, ByVal Srcdx&, ByVal Srcdy&, lpBits As Any, lpBitsInfo As Any, ByVal wUsage&, ByVal dwRop&)

Private MX#, MY#, XUp#, YUp#, XDown#, YDown#, MWidth#, MHeight#, T!

Private oThread1 As cThread, oThread2 As cThread
Attribute oThread1.VB_VarHelpID = -1

Private Sub Form_Activate()
  If oThread1 Is Nothing Then Set oThread1 = CreateObject("DMBSet.cThread")
  If oThread2 Is Nothing Then Set oThread2 = CreateObject("DMBSet.cThread")
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If Not oThread1 Is Nothing Then oThread1.CancelProcessing: Set oThread1 = Nothing
  If Not oThread2 Is Nothing Then oThread2.CancelProcessing: Set oThread2 = Nothing
End Sub

Private Sub cmdRecalc_Click()
  CalcMBSet
End Sub

Private Sub CalcMBSet()
    Dim xStep As Double
    Dim yStep As Double

  T = Timer
  
  If XDown = 0 Then 'not yet zoomed, so we set the "Mandelbrot-Init-Range"
    MX = -2: MWidth = 3.2
    MY = -1.21: MHeight = 2.4
  Else 'use the zoom-coords
    MX = XDown: MWidth = XUp - XDown
    MY = YDown: MHeight = YUp - YDown
  End If
  
  xStep = MWidth / (picSrf.ScaleWidth - 1)
  yStep = MHeight / (picSrf.ScaleHeight - 1)
  
  tmrRefresh.Enabled = True
  tmrRefresh.Tag = vbNullString
  
  If chkSingle.Value Then
    oThread2.CalcMBPart Me, 2, 0, picSrf.ScaleHeight - 1, MX, MY, xStep, yStep, picSrf.ScaleWidth
  Else
    oThread1.CalcMBPart Me, 1, picSrf.ScaleHeight \ 2, 0, MX, MY, xStep, yStep, picSrf.ScaleWidth
    oThread2.CalcMBPart Me, 2, picSrf.ScaleHeight \ 2 + 1, picSrf.ScaleHeight - 1, MX, MY, xStep, yStep, picSrf.ScaleWidth
  End If
End Sub

Private Sub Form_Resize()
  If ScaleHeight < 2 Then Exit Sub Else picSrf.Height = ScaleHeight - 26
End Sub

Private Sub ICallback_RowFinished(ByVal Index As Integer, pRow As Long, ByVal RowIdx As Long)
    DrawArr picSrf.hdc, pRow, 0, RowIdx, picSrf.ScaleWidth, 1
    If Index = 1 Then
        If RowIdx = 0 Then tmrRefresh.Tag = tmrRefresh.Tag & "1"
    Else
        If RowIdx = picSrf.ScaleHeight - 1 Then tmrRefresh.Tag = tmrRefresh.Tag & "2"
    End If
    If Len(tmrRefresh.Tag) = 2 - chkSingle.Value Then FinalizeTiming
End Sub

Private Sub FinalizeTiming()
  lblTiming.Caption = Format(Timer - T, "#0.00sec")
  tmrRefresh.Enabled = False
  tmrRefresh.Tag = vbNullString
  picSrf.Refresh
End Sub
  
Private Sub picSrf_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button <> 1 Then Exit Sub
  shpZoom.Left = x: shpZoom.Width = 0
  shpZoom.Top = y:  shpZoom.Height = 0
  shpZoom.Visible = True
  
  XDown = MX + x * MWidth / picSrf.ScaleWidth
  YDown = MY + y * MHeight / picSrf.ScaleHeight
End Sub

Private Sub picSrf_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button <> 1 Then Exit Sub
  If x - shpZoom.Left > 0 Then shpZoom.Width = x - shpZoom.Left
  If y - shpZoom.Top > 0 Then shpZoom.Height = y - shpZoom.Top
End Sub

Private Sub picSrf_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button <> 1 Then Exit Sub
  If x - shpZoom.Left > 0 Then shpZoom.Width = x - shpZoom.Left
  If y - shpZoom.Top > 0 Then shpZoom.Height = y - shpZoom.Top

  XUp = MX + x * MWidth / picSrf.ScaleWidth
  YUp = MY + y * MHeight / picSrf.ScaleHeight
  shpZoom.Visible = False
  CalcMBSet
End Sub

Private Sub DrawArr(DC&, pArr&, x&, y&, W&, H&)
Dim BI&(9)
  If W = 0 Or H = 0 Then Exit Sub
  BI(0) = 40: BI(1) = W: BI(2) = H: BI(3) = 1 + 65536 * 32 '32bpp
  StretchDIBits DC, x, y, W, H, 0, 0, W, H, ByVal pArr, BI(0), 0, vbSrcCopy
End Sub

Private Sub tmrRefresh_Timer()
  picSrf.Refresh
End Sub
